"use strict";
require('reflect-metadata');
const orm = require('./orm');
function Entity() {
    return (target) => {
        // let tableName = changeCase.snake(target.name);
    };
}
exports.Entity = Entity;
function Extends(base) {
    return (target) => {
        let table = orm.schema.getTable(target);
        let baseTable = orm.schema.getTable(base);
        table.extends = baseTable;
        baseTable.extendedBy.push(table);
        // todo: error if baseTable.idField is not available
        table.idField = table.createField(baseTable.idField.name, baseTable.idField.type);
    };
}
exports.Extends = Extends;
function Field() {
    return (target, propertyKey) => {
        let type = Reflect.getMetadata('design:type', target, propertyKey);
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        if (table.hasField(fieldName))
            return;
        let field = table.createField(fieldName, type);
        if (type == Array)
            field.isArray = true;
    };
}
exports.Field = Field;
function Associate(ref, reversedBy) {
    return (target, propertyKey) => {
        Field()(target, propertyKey);
        if (!ref)
            return; // expecting reversed ref from yet unknown ref
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        let field = table.getField(fieldName);
        let refTable = orm.schema.getTable(ref);
        let refField = refTable.getField(reversedBy);
        if (!refField) {
            throw new Error(`Unknown field ${reversedBy} in ${refTable.name}, referenced by ${tableName}.${fieldName}.`);
        }
        field.associate(refField);
    };
}
exports.Associate = Associate;
function Id() {
    return (target, propertyKey) => {
        Field()(target, propertyKey);
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        let field = table.getField(fieldName);
        table.idField = field;
    };
}
exports.Id = Id;
//# sourceMappingURL=decorators.js.map